#
#	Macros.make	- Makefile for Macros
#
#	Copyright  1989, Claris Corporation.
#
#	This makefile rebuilds the symbol table dump file
#	whenever any of the macro files it includes have changed.

#--------------------------------------------------------------------------------
#	Variables

Module		=	Macros
ModuleDir	=	{AWGS}{Module}:

Makefile	=	{ModuleDir}{Module}.make

MacroFiles	=	{ModuleDir}m16.bob	
				{ModuleDir}m16.branch	
				{ModuleDir}m16.cmp	
				{ModuleDir}m16.eval	
				{ModuleDir}m16.math	
				{ModuleDir}m16.move	
				{ModuleDir}m16.msl	
				{ModuleDir}m16.stack	
				{ModuleDir}m16.tools	
				{ModuleDir}m16.utility	
				{ModuleDir}e16.tools

#--------------------------------------------------------------------------------
#	Main target

{ModuleDir}Macros.dump		{MacroFiles} {MakeFile}
	@echo "# Creating {ModuleDir}DumpMacros.aii "
	@echo > {ModuleDir}DumpMacros.aii
	@for i in {MacroFiles}; 
		@echo "tincludet'{i}'" >> {ModuleDir}DumpMacros.aii; 
	@end
	@echo >> {ModuleDir}DumpMacros.aii
	@echo "tDUMPt'{ModuleDir}Macros.dump'" >> {ModuleDir}DumpMacros.aii
	@echo "tEND" >> {ModuleDir}DumpMacros.aii
	AsmIIGS	{ModuleDir}DumpMacros.aii -c	# don't even bother with object.
	Delete {ModuleDir}DumpMacros.aii		# don't need source files

clean	
	@confirm "Delete {ModuleDir}Macros.dump"
	@if {status} == 0 then
		delete	{ModuleDir}Macros.dump
	@end
