/***********************************************************************\

	Product Number: PROXLIB-01-2.0

	Version: rev2.0

	Product Name: Proximity Subroutine Library

	Filename: proxio.h


	This document contains private and confidential information and
	its disclosure does not constitute publication.  Some of the
	information herein also may appear in United States and or
	Foreign Patents Pending.  All rights are reserved by Proximity
	Technology Inc., except those specifically granted by license.

\***********************************************************************/

#ifndef _PROXIO
#define _PROXIO

#ifndef _PROXLIB
#include "proxlib.h"
#endif

/* The handle is used for the file interface, it must be long enough to 
   store the file descriptor used by the std..  routines.  */ 

typedef long    HANDLE;

/* These things are used for our std... I/O open routine. */

#define H_RDONLY 0              /* mode for reading a file */
#define H_RDWR   1              /* mode for reading and writing */
#define H_CREAT  2              /* mode for creating and writing a file */

#define H_ERROR -1L             /* standard error value is -1 */

extern HANDLE stdopen();        /* open a file */
extern int stdclose();          /* close a file */
extern int stdread();           /* read bytes */
extern int stdwrite();          /* write bytes */
extern int stdseek();           /* position a file */
extern long stdend();           /* find the end of a file */

extern int abytread();          /* allocate memory and read bytes into it. */
extern int ashtread();          /* allocate memory and read shorts into it. */
extern int bytread();           /* read bytes */
extern int shtread();           /* read shorts */

#endif /* _PROXIO */
