/***********************************************************************\

	Product Number: PROXLIB-01-2.0

	Version: rev2.0

	Product Name: Proximity Subroutine Library

	Filename: ssearch.h


	This document contains private and confidential information and
	its disclosure does not constitute publication.  Some of the
	information herein also may appear in United States and or
	Foreign Patents Pending.  All rights are reserved by Proximity
	Technology Inc., except those specifically granted by license.

\***********************************************************************/

#ifndef _SSEARCH
#define _SSEARCH

#ifndef _PROXLIB
#include "proxlib.h"
#endif

#define SS_NOMATCH 0       /* return value if query not found */
#define SS_PREFIX  1       /* return value if query is a prefix of a string */
#define SS_MATCH   (-1)    /* return value if query found */

typedef struct {
	UCHAR   *ss_strings;    /* Pointer to the string table */
	unsigned int ss_length; /* Length of the string table */
	int     ss_offset;      /* Bytes to skip before compare */
	int     ss_type;        /* Search type */
	UCHAR   *ss_posn;       /* Last search position */
} SSRCHTAB;

extern int ssearch();           /* The string search function */

#endif
